/* Define procedures MidiOpen, MidiClose, and MidiMessage */

#include "stdio.h" 
#include "portmidi.h"

PmStream *midi_out;      /* the MIDI out stream */
PmError err;             /* for errors in opening  */

/* open Nth portmidi output device (first = 0)*/
void MidiOpen(int n) {
  int i;
  Pm_Initialize();
  for (i = 0; i < Pm_CountDevices(); i++) {
    const PmDeviceInfo *info = Pm_GetDeviceInfo(i);
    if (info->output) {
      if (n == 0) {
        break;
      } else { n -= 1; }
    }
  }
  if (n > 0) fprintf(stderr,"PortMidi: Not enough output devices\n");
  if (err=Pm_OpenOutput(&midi_out, i, NULL, 512, NULL, NULL,1)) {
    fprintf(stderr,"PortMIDI: %s\n",Pm_GetErrorText(err));
  }
}

/* send midi message via the portmidi device */
void MidiMessage(int x, int y, int z) {
  Pm_WriteShort(midi_out, 0, Pm_Message(x, y, z));
}

/* close the portmidi device */
void MidiClose() {
  Pm_Close(midi_out);
  Pm_Terminate();
}
