#lang racket

(require scheme/foreign)
(provide midi-open midi-close message)
(unsafe!)

(define midilib (ffi-lib "portmidi-output.dylib"))
(define (ffi-load name format) 
  (get-ffi-obj name midilib format (lambda () (error "Load error: ~s" name))))

(define MidiOpen (ffi-load "MidiOpen" (_fun _int -> _void)))
(define MidiClose (ffi-load "MidiClose" (_fun -> _void)))
(define MidiMessage (ffi-load "MidiMessage" (_fun _int _int _int -> _void)))

(define (midi-open num) (MidiOpen num) #t)
(define (midi-close dev) (MidiClose))
(define (message dev x y z) (MidiMessage x y z))


