#lang racket

;;;  This allows the pc-ivl-lib from Impromptu by Andrew Sorensen to be used.
;;;  See the README for how to prepare the file andrew-pc-ivl-lib.scm first.

(require (rename-in racket/base [random rkt:random] [if rkt:if]))
(require (file "spur.scm") (lib "defmacro.ss"))

(provide (except-out (all-defined-out)
            fmod print-notification cl:sort cl:remove 
            cl:find-if remove-first cl:intersection if random))

;; some definitions needed for Impromptu 
(define fmod modulo)

(define print-notification error)

(define cl:sort sort)

(define cl:remove remove)

(define cl:find-if findf)

(define remove-first remove)

(define (cl:intersection x y)              ; tail-recursive list intersection
  (let loop ((x x) (ans '()))
    (if (null? x) ans
        (if (member (car x) y) (loop (cdr x) (cons (car x) ans))
            (loop (cdr x) ans)))))

(define-macro (if test true . rest)        ; instead of the Racket if
  (if (null? rest) `(when ,test ,true) `(rkt:if ,test ,true ,(car rest))))

(define random rand)                       ; instead of the Racket random

(include "andrew-pc-ivl-lib.scm")          ; now load the pc-ivl-lib!
